# This file is part of pybib2html, a translator of BibTeX to HTML.
# https://gitlab.com/sosy-lab/software/pybib2html
#
# SPDX-FileCopyrightText: 2021 Dirk Beyer <https://www.sosy-lab.org>
#
# SPDX-License-Identifier: Apache-2.0

from typing import Any, Sequence, Dict

logger: Any
STANDARD_TYPES: Any
COMMON_STRINGS: Any

class UndefinedString(KeyError): ...

class BibDatabase:
    entries: Sequence[Dict[str, str]]
    comments: Any
    strings: Any
    preambles: Any
    def __init__(self) -> None: ...
    def load_common_strings(self) -> None: ...
    def get_entry_list(self): ...
    @staticmethod
    def entry_sort_key(entry, fields): ...
    def get_entry_dict(self): ...
    entries_dict: Any
    def expand_string(self, name): ...
    def add_missing_from_crossref(self) -> None: ...

class BibDataString:
    name: Any
    def __init__(self, bibdatabase, name) -> None: ...
    def __eq__(self, other): ...
    def get_value(self): ...
    def get_dependencies(self, known_dependencies=...) -> None: ...
    @staticmethod
    def expand_string(string_or_bibdatastring): ...

class BibDataStringExpression:
    expr: Any
    def __init__(self, expression) -> None: ...
    def __eq__(self, other): ...
    def get_value(self): ...
    def apply_on_strings(self, fun) -> None: ...
    @staticmethod
    def expand_if_expression(string_or_expression): ...
    @staticmethod
    def expression_if_needed(tokens): ...

def as_text(text_string_or_expression): ...
